#
# spec file for package snort (Version 2.4.4)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs e2fsprogs-devel file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd krb5 krb5-devel less libacl libattr libcom_err libgcc libnscd libpcap libstdc++ libstdc++-devel libtool libxcrypt libxml2 libxml2-devel libzio m4 make man mktemp module-init-tools mysql-client mysql-devel mysql-shared ncurses ncurses-devel net-tools netcfg openldap2-client openssl openssl-devel pam pam-modules patch pcre pcre-devel perl permissions popt postgresql-devel postgresql-libs procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unixODBC unixODBC-devel unzip util-linux vim zlib zlib-devel

Name:           snort
BuildRequires:  krb5-devel libpcap libxml2-devel mysql-devel openssl-devel pcre-devel postgresql-devel unixODBC-devel
%define with_mysql 	1
%define with_pgsql 	1
%define with_odbc 	1
%define libnet_version 	1.0.2a
Summary:        A Packet Sniffer and Logger
Version:        2.4.4
Release:        10.4
Group:          Productivity/Networking/Diagnostic
License:        GPL
Requires:       logrotate
Source0:        http://www.snort.org/dl/%{name}-%{version}.tar.bz2
Source1:        %{name}-update
Source2:        %{name}.init
Source4:        %{name}.sysconfig
Source5:        %{name}.ifup
Source6:        snortrules-pr-2.4.tar.bz2
Source7:        http://www.snort.org/dl/contrib/data_analysis/snort_stat.pl
Source8:        http://www.snort.org/dl/contrib/data_analysis/snortlog3.pl
Source9:        Community-Rules.tar.bz2
Source100:      http://www.packetfactory.net/libnet/dist/deprecated/libnet-%{libnet_version}.tar.bz2
Patch1:         %{name}-2.2.0-config.patch
Patch2:         %{name}-2.4.3-lib64_configure.patch
Patch3:         %{name}-2.1.1-logrotate.patch
Patch4:         http://www.demarc.com/files/patch_20060531/snort-2.4.4-demarc-patch.diff
Patch100:       libnet-multiline-string-fix.diff
Patch101:       libnet-strict-aliasing.diff
URL:            http://www.snort.org/
#%if %{with_pgsql}
#Buildrequires: postgresql-devel, postgresql-lib
#%endif
#%if %{with_mysql}
#BuildRequires: mysql-devel
#BuildRequires: mysql-client
#%endif
#%if %{with_odbc}
#Buildrequires: unixodbc-devel
#%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Prereq:         /usr/sbin/useradd /usr/sbin/groupadd %insserv_prereq %fillup_prereq

%description
Snort is a libpcap-based packet sniffer and logger which can be used as
a lightweight network intrusion detection system. It features rules
based logging and can perform protocol analysis, content searching, and
matching. It can be used to detect a variety of attacks and probes,
such as buffer overflows, stealth port scans, CGI attacks, SMB probes,
OS fingerprinting attempts, and many more. Snort has a real-time alert
capability, with alerts being sent to syslog, a separate "alert" file,
or as a WinPopup message via Samba's smbclient. Additionally, the
snort-log-analyzer (5n0r7) is included.



Authors:
--------
    Marty Roesch <roesch@clark.net> (snort)
    Michel Kaempf <maxx@via.ecp.fr> (5n0r7)

%debug_package
%prep
%setup -q -a 6 -a 100
%patch1 -p1 -b .config
#%ifarch x86_64 ia64 ppc64 s390x
%patch2
#%endif
%patch3 -p2 -b .logrotate
%patch4 -p1
cd Libnet-%{libnet_version}
%patch100
%patch101
cd ..

%build
# -----------------------------------------------------------------
# build libnet-1.0.2a first (currently only working version) 
cd Libnet-%{libnet_version}
%{?suse_update_config:%{suse_update_config}}
autoconf
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} \
	--with-pf_packet=yes \
	--libdir=%{_libdir}
make CFLAGS="$RPM_OPT_FLAGS"
make CFLAGS="$RPM_OPT_FLAGS" test
make CFLAGS="$RPM_OPT_FLAGS" install
LIBNET=$RPM_BUILD_DIR/${RPM_PACKAGE_NAME}-${RPM_PACKAGE_VERSION}/Libnet-%{libnet_version}
cd ..
#-----------------------------------------------------------------
#...and now build snort
#autoreconf
autoconf
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" LIBS="-libdl" \
%configure \
	--with-openssl=%{_prefix} \
	--with-snmp \
%if %{with_mysql}
	--with-mysql \
%endif
%if %{with_pgsql}
	--with-psql-includes=%{_prefix} \
	--with-postgresql=%{_libdir} \
%endif
%if %{with_odbc}
	--with-odbc \
%endif
	--enable-perfmonitor \
	--enable-linux-smp-stats \
	--enable-flexresp \
	--sysconfdir=%{_sysconfdir}/%{name} \
	--with-libnet-includes=$LIBNET/include \
	--with-libnet-libraries=$LIBNET/lib \
	--with-libxml2-includes=%{_includedir} \
	--localstatedir=%{_localstatedir}/lib
make

%install
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p -m 0750 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/rules
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/init.d
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}/archive
mkdir -p -m 0700 $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}
install -m 640 rules/*.rules $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/rules
install -m 640 etc/*.map $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -m 640 etc/*.config $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -m 640 etc/generators $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -m 640 etc/sid $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -m 640 etc/*.conf $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -m 755 %{_sourcedir}/snort.init $RPM_BUILD_ROOT%{_sysconfdir}/init.d/snort
install -d -m 755 $RPM_BUILD_ROOT/etc/logrotate.d
install -m 644 rpm/snort.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/snort
mkdir -p %{buildroot}/%{_sbindir}
cd %{buildroot}/%{_sbindir}
ln -s ../../%{_sysconfdir}/init.d/snort rcsnort
cd -
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
install -m 755 %{_sourcedir}/snort-update $RPM_BUILD_ROOT%{_sbindir}
install etc/reference.config $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/adm/fillup-templates/
install -m 644 %{_sourcedir}/snort.sysconfig $RPM_BUILD_ROOT%{_localstatedir}/adm/fillup-templates/sysconfig.snort
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/network/if-up.d
install -m 755 %{_sourcedir}/snort.ifup $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/network/if-up.d/snortstart
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ppp/ip-up.d
install -m 755 %{_sourcedir}/snort.ifup $RPM_BUILD_ROOT%{_sysconfdir}/ppp/ip-up.d/snortstart
cd contrib
mv README README.contrib
cp -p %{SOURCE7} .
cp -p %{SOURCE8} .
for i in snortdb-extra snortnet.tar snortwatch-0.7.tar Guardian.tar Net-SnortLog-0.1.tar ACID-0.9.6b21.tar Spade-092200.1.tar ; do
	zcat "$i".gz | bzip2 -9 > "$i".bz2
done
cd ..
tar xf %{SOURCE9} -C $RPM_BUILD_ROOT/etc/snort rules 
tar xf %{SOURCE9} -C doc/signatures docs
mv doc/signatures/docs/* doc/signatures
rmdir doc/signatures/docs
bzip2 -9 doc/signatures/*

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -g 68 -o -r snort 2> /dev/null || :
/usr/sbin/useradd -r -o -g snort -u 73 -s /bin/bash -c "Snort network monitor" \
-d %{_localstatedir}/lib/%{name} snort 2> /dev/null || :

%post
%{fillup_only -n snort}

%preun
# we won't remove the snort user here because of the logs that
# are probably being left behind
if [ $1 = 0 ]; then
	%{_sysconfdir}/init.d/snort stop > /dev/null 2>&1 || :
fi

%postun
%{insserv_cleanup}

%files
%defattr(-,root,root)
%{_sysconfdir}/sysconfig/network/if-up.d/snortstart
%{_sysconfdir}/ppp/ip-up.d/snortstart
%attr(0755,root,snort) %dir %{_sysconfdir}/snort
%attr(0755,root,snort) %dir %{_sysconfdir}/snort/rules
%attr(0640,root,snort) %config(noreplace) %{_sysconfdir}/snort/[cgstu]*
%attr(0640,root,snort) %config(noreplace) %{_sysconfdir}/snort/reference.config
%attr(0640,root,snort) %config(noreplace) %{_sysconfdir}/snort/rules/*
%{_sysconfdir}/init.d/snort
%config(noreplace) /etc/logrotate.d/snort
%{_bindir}/*
%{_sbindir}/*
%attr(750,snort,snort) %dir %{_localstatedir}/log/snort
%attr(750,snort,snort) %dir %{_localstatedir}/log/snort/archive
%attr(750,snort,snort) %dir %{_localstatedir}/lib/%{name}
%{_mandir}/man8/snort.8*
%{_localstatedir}/adm/fillup-templates/sysconfig.snort
%doc COPYING ChangeLog LICENSE
%doc doc/AUTHORS doc/BUGS doc/CREDITS doc/INSTALL doc/NEWS
%doc doc/PROBLEMS doc/README* doc/RULES.todo doc/TODO doc/USAGE
%doc doc/WISHLIST doc/faq.pdf doc/faq.tex doc/signatures
%doc doc/snort_manual.pdf doc/snort_manual.tex doc/snort_schema_v106.pdf
%doc contrib/ACID-0.9.6b21.tar.bz2 contrib/Guardian.tar.bz2
%doc contrib/Net-SnortLog-0.1.tar.bz2 contrib/README.contrib
%doc contrib/Spade-092200.1.tar.bz2 
%doc contrib/snortdb-extra.bz2 contrib/snortnet.tar.bz2
%doc contrib/snortwatch-0.7.tar.bz2
%doc contrib/snort_stat.pl contrib/snortlog3.pl
%doc schemas

%changelog -n snort
* Wed Jun 07 2006 - kssingvo@suse.de
- fixed issue in URI reassembling CVE-2006-2769 (bugzilla#181142)
* Thu Mar 09 2006 - dmueller@suse.de
- update to 2.4.4: Fixes evasion with fragmented packets
  containing ip options (#152680)
- extract Community Rules
* Wed Feb 22 2006 - dmueller@suse.de
- community rules update (2006-02-16)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Nov 15 2005 - dmueller@suse.de
- update to 2.4.3
* Tue Nov 15 2005 - dmueller@suse.de
- fix strict aliasing issues
* Mon Oct 24 2005 - kssingvo@suse.de
- security fix for backorifice BOf CVE-2005-3252 (bugzilla#129047)
* Tue Oct 18 2005 - kssingvo@suse.de
- security fix for package printing in verbose mode (bugzilla#117184)
* Wed Jul 27 2005 - kssingvo@suse.de
- update to 2.3.3
- worked a bit on OpenSource rules, but only first step is done
* Tue Feb 15 2005 - kssingvo@suse.de
- update to 2.3.0
- added 2.3.0 rules
- added removed contrib stuff from website
- dropped outdated contrib stuff (and no replacement found at website)
* Mon Oct 25 2004 - kssingvo@suse.de
- changed heimdal-devel to kerberos-devel-packages in #neededforbuild
- updated snortrules
* Mon Aug 23 2004 - kssingvo@suse.de
- cleaned up /etc/snort
* Wed Aug 18 2004 - kssingvo@suse.de
- upgrade to 2.2.0
- enable nice and new configure features
- fixed and adapted patches
- added doc/signatures (and compressed them as supported)
- updated %%doc
* Wed Jun 02 2004 - kssingvo@suse.de
- fixed path in logrotate config (bugzilla#41539)
- added missing threshold.conf (bugzilla#39742)
* Thu May 06 2004 - kssingvo@suse.de
- added missing maps (bugzilla#39742)
* Thu Apr 29 2004 - ro@suse.de
- added -fno-strict-aliasing
* Thu Mar 04 2004 - kssingvo@suse.de
- upgrade to 2.1.1
- fixed/adapted %%doc's
- added logrotate support
- delivering rules now for snort version 2.1.x
* Wed Jan 28 2004 - kssingvo@suse.de
- apply lib64 patch on s390x (taken from main branch)
- upgrade to version 2.1.0 (bugzilla#33475)
- added pcre in neededforbuild
- updated document names
- updated files of contrib part
- fixed lib64 patch for better search order of lib64 pathes
- updated snortrules-current.tar.gz too
* Tue Nov 18 2003 - kssingvo@suse.de
- updated to version 1.0.4 and snortrules to rules-set-of-the-day
- added heimdal-lib to fix postgresql linking problem
* Mon Nov 10 2003 - ro@suse.de
- use net-snmp instead of ucdsnmp (really used ?)
* Fri Aug 29 2003 - kukuk@suse.de
- Call useradd with -r for system accounts [Bug #29611]
* Mon Aug 18 2003 - kssingvo@suse.de
- updated metadata in sysconfig file (bugzilla#28940)
* Thu Aug 14 2003 - ro@suse.de
- fixed chown usage in init script
* Mon Aug 11 2003 - kssingvo@suse.de
- added ppc64 to 64bit arch patch
* Tue Aug 05 2003 - kssingvo@suse.de
- configure fixes for 64bit arch
* Wed Jul 30 2003 - kssingvo@suse.de
- libnet needs an autoreconf under any 64bit arch, and autoreconf seems
  to work und ix86 either --> now default
* Tue Jul 29 2003 - kssingvo@suse.de
- libnet requires under ia64 a autoreconf to check for <net/ethernet.h>
* Mon Jul 28 2003 - kssingvo@suse.de
- updated to new version 2.0.1
- fixed problem with incompatible, new libnet: linking with static, old version
* Wed Jun 11 2003 - kssingvo@suse.de
- fixed path of ppp startup: /etc/ppp/if-up.d -> /etc/ppp/ip-up.d
* Wed Jun 11 2003 - kssingvo@suse.de
- updated to new version 2.0.0 (incl. rules file)
- adjusted patches to new version
- removed obsolete chmod's
- added much more data from contrib to %%doc (and compressed them with bzip2)
- removed unused comment from %%post
- updated %%post: %%{fillup_and_insserv} -> %%{fillup_only} to reflect
  new SuSE security policy
- updated old init script
- did some runtime tests
* Thu Mar 06 2003 - kssingvo@suse.de
- fix for configuration file snort.conf
* Tue Mar 04 2003 - kssingvo@suse.de
- updated to 1.9.1 (security problem in previous versions)
  and updated fitting rules set too
* Tue Dec 10 2002 - mmj@suse.de
- Add sysconfig metadata
* Tue Nov 19 2002 - ro@suse.de
- removed duplicates in configure.in
* Sun Aug 25 2002 - olh@suse.de
- fix typo in specfile
* Mon Aug 19 2002 - uli@suse.de
- fixed to find several libs in /usr/lib64
* Fri Aug 09 2002 - mmj@suse.de
- Added $PATH and install snortstart in /etc/ppp/if-up.d [#17536]
* Thu Aug 08 2002 - mmj@suse.de
- Merge the Conectiva snort package from Andreas Hasenack
* Wed Apr 24 2002 - mge@suse.de
- update to 1.8.6 (fixes include-file problems)
- tested on ia32, ppc and some 64bit platforms
* Wed Mar 20 2002 - mge@suse.de
- update to 1.8.4 (fixes bug #13247)
- update snort-stat ( aka snort_stat.pl ) to 1.15.2.6
- update snortlog ( aka snortlog3.pl )
- let names of snort-stat and snortlog unchanged
  for compatibility reasons
* Fri Mar 01 2002 - pthomas@suse.de
- Correct english part of the mail sent after installation.
* Sun Feb 17 2002 - kukuk@suse.de
- Use rc_exit in init script [Bug #13324]
* Wed Feb 06 2002 - ro@suse.de
- don't assume anything about buildroot
* Tue Jan 15 2002 - egmont@suselinux.hu
- removed colon from startup message
* Mon Jan 14 2002 - ro@suse.de
- removed START_SNORT
- moved SORT_OPTS to /etc/sysconfig/snort
* Thu Sep 06 2001 - schwab@suse.de
- Remove extra text from rc.config.snort.
* Sun Aug 26 2001 - mge@suse.de
- updated 5n0r7.c to new log-file-format.
  Thanks to Michel "MaXX" Kaempf <maxx@via.ecp.fr>
-  fixed /etc/init.d/snort status-handling (bug #9095)
* Fri Aug 24 2001 - lmuelle@suse.de
- Remove Requires: libpcapn libnet
- Split 5n0r7.c.diff in 5n0r7.c and 5n0r7.readme and put rc.config parts
  in source files
* Fri Aug 24 2001 - lmuelle@suse.de
- Update to 1.8.1; fixes outstanding bugs; more stable than 1.8
  New features: SNMP alerts, IDMEF XML output, limited wildcard regex
  support, new normilization mode for http_decode
- Main configuration file moved in upstream from /etc/snort/snort-lib
  to /etc/snort/snort.conf
- Convert old configuration file, if necessary, while update
- Convert SNORT_OPTS config file oriented part while update in rc.config
- Include SnortUsersManual.pdf and snort man page
* Thu Aug 09 2001 - ro@suse.de
- use libpcap instead of (dropped) libpcapn
* Thu May 10 2001 - mfabian@suse.de
- bzip2 sources
* Thu Jan 25 2001 - mge@suse.de
- update to snort-1.7
- fixed bugzilla bugs: #5187, #5366
- "notify" for yast, to configure "/etc/snort/snort-lib"
* Mon Dec 04 2000 - mge@suse.de
- update to snort-1.6.3-patch2, new /etc/init.d handling
* Mon Jul 24 2000 - mge@suse.de
- update to 1.6.3
* Thu Jul 13 2000 - mge@suse.de
- added symlinks to /etc/rc.d/rc2.d /etc/rc.d/rc3.d
* Fri Jul 07 2000 - mge@suse.de
- initial SuSE RPM
- added 5n0r7 by Michel Kaempf <maxx@via.ecp.fr>
  ftp://snort.via.ecp.fr/5n0r7/5n0r7.c
* Tue Mar 28 2000 - William Stearns <wstearns@pobox.com>
- Quick update to 1.6.
- Sanity checks before doing rm-rf in install and clean
* Fri Dec 10 1999 - Henri Gomez <gomez@slib.fr>
- 1.5-0 Initial RPM release
